#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <math.h>
#include <graphics.h>
#include <dos.h>

#define r 0.05

int i, j, k;
float matrix[4][4],
      F[6][4] = { {18, 69, 0, 1},
                  {69, -18, 0, 1},
                  {0, 0, -71, 1},
                  {-18, -69, 0, 1},
                  {-69, 18, 0, 1},
                  {0, 0, 71, 1} },
      G[6][4];

void DrawFigure(int _color)
{
  setcolor(_color);
  for(i=0;i<6;i++)
    for(j=0;j<6;j++)
      if(i<j&&j-i!=3) line(F[i][0]+200, F[i][1]+200, F[j][0]+200, F[j][1]+200);
}

void MultMat()
{
  for(k=0;k<6;k++)
    for(i=0;i<4;i++)
    {
      G[k][i]=0;
      for (j=0;j<4;j++)
        G[k][i]+=F[k][j]*matrix[j][i];
    }
}

void EraseMat()
{
  for(i=0;i<4;i++)
    for(j=0;j<4;j++)
      matrix[i][j] = 0;
}

void Morphs()
{
  MultMat();
  DrawFigure(0);
  for(i=0;i<6;i++)
    for(j=0;j<4;j++)
      F[i][j] = G[i][j];
}

int main(void)
{
  int gdriver = DETECT, gmode, errorcode;
  char Key;
  initgraph(&gdriver, &gmode, "");
  errorcode = graphresult();
  if (errorcode != grOk)
  {
    printf("Graphics error: %s\n", grapherrormsg(errorcode));
    printf("Press any key to halt:");
    getch();
    exit(1);
  }
  DrawFigure(15);
  while(Key!=27)
  {
    switch(Key = getch())
    {
      case 119 : EraseMat();
                 matrix[0][0]=1;
                 matrix[1][1]=cos(-r);
                 matrix[1][2]=-sin(-r);
                 matrix[2][1]=sin(-r);
                 matrix[2][2]=cos(-r);
                 matrix[3][3]=1;
                 Morphs();
                 DrawFigure(15);
                 break;
      case 115 : EraseMat();
                 matrix[0][0]=1;
                 matrix[1][1]=cos(r);
                 matrix[1][2]=-sin(r);
                 matrix[2][1]=sin(r);
                 matrix[2][2]=cos(r);
                 matrix[3][3]=1;
                 Morphs();
                 DrawFigure(15);
                 break;
      case 113 : EraseMat();
                 matrix[0][0]=cos(-r);
                 matrix[0][2]=-sin(-r);
                 matrix[1][1]=1;
                 matrix[2][0]=sin(-r);
                 matrix[2][2]=cos(-r);
                 matrix[3][3]=1;
                 Morphs();
                 DrawFigure(15);
                 break;
      case 101 : EraseMat();
                 matrix[0][0]=cos(r);
                 matrix[0][2]=-sin(r);
                 matrix[1][1]=1;
                 matrix[2][0]=sin(r);
                 matrix[2][2]=cos(r);
                 matrix[3][3]=1;
                 Morphs();
                 DrawFigure(15);
                 break;
      case 97  : EraseMat();
                 matrix[0][0]=cos(-r);
                 matrix[0][1]=-sin(-r);
                 matrix[1][0]=sin(-r);
                 matrix[1][1]=cos(-r);
                 matrix[2][2]=1;
                 matrix[3][3]=1;
                 Morphs();
                 DrawFigure(15);
                 break;
      case 100 : EraseMat();
                 matrix[0][0]=cos(r);
                 matrix[0][1]=-sin(r);
                 matrix[1][0]=sin(r);
                 matrix[1][1]=cos(r);
                 matrix[2][2]=1;
                 matrix[3][3]=1;
                 Morphs();
                 DrawFigure(15);
                 break;
    }
  }
  closegraph();
  return 0;
}
